
/*
*===========================================================
*        File Name: adc.h
*          Version: A1
*          Created: 2015-8-14
*         Revision: 00
*         Compiler: ARMCC.exe V5.03.0.76
*           Author: 
*          Company: Analog Devices Inc
*===========================================================
*/

#ifndef ADC_H_
#define ADC_H_

#include "inc\ADuCM360.h"
#include "inc\system_ADUCM360.h"
#include "common\AdcLib.h"
#include "hardware.h"
#include "common\IexcLib.h"

#define ADC_UPDATE_INDEX_INIT	2			//50Hz
#define ADC_UPDATE_VALID_NUM	8

typedef union {
	struct {
		unsigned short SF 				: 7;
		unsigned short NOTCH2 		: 1;
		unsigned short AF					: 4;
		unsigned short SINC4EN		: 1;
		unsigned short Reserved		: 1;
		unsigned short RAVG2			: 1;
		unsigned short CHOP				: 1;
	}Bits;
	unsigned short Val;
} ADCFLT_T;

typedef struct{
	float		 			 const ADC_UPD_RATE[8];	//recommended ADC Update Rate with verified performance.
	unsigned short const ADCFLT_VALUE[8];	//recommended ADCFTL Value
	void(*init_bat_volt_curr)(unsigned char updrate_index);
	void(*init_bat_temp_vdac)(unsigned char updrate_index);
	void(*init_bat_temp_sync)(unsigned char updrate_index);
	void(*iext_curr_on)(void);
	void(*iext_curr_off)(void);
	void(*sync_start)(void);
	void(*odr_tsettle)(unsigned short ADCFLT, float* fADC, float* tsettle);
	unsigned int (*raw_ch0)(void);
	unsigned int (*raw_ch1)(void);
} ADC_T;

extern ADC_T adc;



#endif /*ADC_H_*/
