
/*
*===========================================================
*        File Name: adp5065.h
*          Version: A1
*          Created: 2015-8-14
*         Revision: 00
*         Compiler: ARMCC.exe V5.03.0.76
*           Author: 
*          Company: Analog Devices Inc
*===========================================================
*/
#ifndef ADP5065_H_
#define ADP5065_H_

#include "inc\ADuCM360.h"
#include "inc\system_ADUCM360.h"
#include "i2c.h"

#define I2CID_ADP5065 0x28
#define SIZE_ADP5065_WRITABLE_REG			9
#define SIZE_ADP5065_READABLE_REG			14

#define ADP5065_REGID_MANUINFO		((unsigned char)0)
#define ADP5065_REGID_SILICONVER	((unsigned char)1)
#define ADP5065_REGID_VINXSET			((unsigned char)2)
#define ADP5065_REGID_TERMSET			((unsigned char)3)
#define ADP5065_REGID_CHARGECUR		((unsigned char)4)
#define ADP5065_REGID_VOLTTHR			((unsigned char)5)
#define ADP5065_REGID_TIMERSET		((unsigned char)6)
#define ADP5065_REGID_FUNCSET1		((unsigned char)7)
#define ADP5065_REGID_FUNCSET2		((unsigned char)8)
#define ADP5065_REGID_INTENSET		((unsigned char)9)
#define ADP5065_REGID_INTACTSTA		((unsigned char)10)
#define ADP5065_REGID_CHARGERSTA1	((unsigned char)11)
#define ADP5065_REGID_CHARGERSTA2	((unsigned char)12)
#define ADP5065_REGID_FAULTREG		((unsigned char)13)
#define ADP5065_REGID_BATSHORT		((unsigned char)16)
typedef union{		//ADP5065_REG_MANUINFO_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	Model	:	4;			 
	 __IO uint8_t	MANUF	:	4;
 } BITs;
}ADP5065_REG_MANUINFO_T;
typedef union{		//ADP5065_REG_SILICONVER_T
 __IO uint8_t  Val;
 struct{					
	 __IO uint8_t	SiRev   : 4;
	 __IO uint8_t	Reserve : 4; 
 } BITs;
}ADP5065_REG_SILICONVER_T;
typedef union{		//ADP5065_REG_VINXSet_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	ILIM    : 4;
	 __IO uint8_t	Reserve : 4; 
 } BITs;
}ADP5065_REG_VINXSet_T;
typedef union{		//ADP5065_REG_TERMSET_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	IEND    : 2;
	 __IO uint8_t	VTRM    : 6; 
 } BITs;
}ADP5065_REG_TERMSET_T;
typedef union{		//ADP5065_REG_CHARGECURR_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	ITRK_DEAD    : 2;
	 __IO uint8_t	ICHG         : 3; 
	 __IO uint8_t	Reserve 		 : 1; 
	 __IO uint8_t	C_10EOC 		 : 1; 
	 __IO uint8_t	C_20EOC 		 : 1;  
 } BITs;
} ADP5065_REG_CHARGECURR_T;
typedef union{		//ADP5065_REG_VOLTTHR_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	VWEAK    		: 3;
	 __IO uint8_t	VTRK_DEAD   : 2; 
	 __IO uint8_t	VRCH	  		: 2; 
	 __IO uint8_t	Reserve 		: 1; 
 } BITs;
}ADP5065_REG_VOLTTHR_T;
typedef union{		//ADP5065_REG_TIMERSET_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	RESET_WD   			  : 1;
	 __IO uint8_t	WD_PERIOD   			: 1; 
	 __IO uint8_t	EN_WD       			: 1; 
	 __IO uint8_t	CHG_TMR_PERIOD		: 1; 
	 __IO uint8_t	EN_CHG_TIMER      : 1;  
	 __IO uint8_t	EN_TEND           : 1;  
	 __IO uint8_t	Reserve           : 2;  
 } BITs;
}ADP5065_REG_TIMERSET_T;
typedef union{		//ADP5065_REG_FUNCSET1_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	EN_CHG   			  : 1;
	 __IO uint8_t	EN_TRK   			  : 1; 
	 __IO uint8_t	EN_EOC       		: 1; 
	 __IO uint8_t	Reserve		      : 1; 
	 __IO uint8_t	EN_THR          : 1;  
	 __IO uint8_t	EN_BMON         : 1;  
	 __IO uint8_t	DIS_IPK_SD      : 1;  
	 __IO uint8_t	EN_JEITA        : 1;  
 } BITs;
}ADP5065_REG_FUNCSET1_T;
typedef union{		//ADP5065_REG_FUNCSET2_T
 __IO uint8_t  Reserve;
} ADP5065_REG_FUNCSET2_T;
typedef union{		//ADP5065_REG_INTENSET_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	EN_VIN_INT   			  : 1;
	 __IO uint8_t	EN_CHG_INT   			  : 1; 
	 __IO uint8_t	EN_BAT_INT       		: 1; 
	 __IO uint8_t	EN_THR_INT		      : 1; 
	 __IO uint8_t	EN_TSD_INT          : 1;  
	 __IO uint8_t	EN_WD_INT           : 1;  
	 __IO uint8_t	EN_THERM_LIM_INT    : 1;  
	 __IO uint8_t	EN_IND_PEAK_INT     : 1;  
 } BITs;
}ADP5065_REG_INTENSET_T;
typedef union{		//ADP5065_REG_INTACTSTA_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	VIN_INT   			 : 1;
	 __IO uint8_t	CHG_INT   			 : 1; 
	 __IO uint8_t	BAT_INT       	 : 1; 
	 __IO uint8_t	THR_INT		       : 1; 
	 __IO uint8_t	TSD_INT          : 1;  
	 __IO uint8_t	WD_INT           : 1;  
	 __IO uint8_t	THERM_LIM_INT    : 1;  
	 __IO uint8_t	IND_PEAK_INT     : 1;  
 } BITs;
}ADP5065_REG_INTACTSTA_T;

typedef enum {		//CHARGER_STATUS_E_T
	CHARGER_STATUS_OFF = 0,
	CHARGER_STATUS_TRICKLE_CHARGE = 1,
	CHARGER_STATUS_FAST_CC = 2,
	CHARGER_STATUS_FAST_CV = 3,
	CHARGER_STATUS_CHARGE_COMPLETE = 4,
	CHARGER_STATUS_SUSPEND = 5,
	CHARGER_STATUS_Ttirk_Twd_EXPRIED = 6,
	CHARGER_STATUS_BATTERY_DETECTION = 7
} CHARGER_STATUS_E_T;

typedef union{		//ADP5065_REG_CHARGERSTA1_T
 __IO uint8_t  Val;
 struct{
	 CHARGER_STATUS_E_T CHARGER_STATUS : 3;
//	 __IO uint8_t	CHARGER_STATUS     : 3;
	 __IO uint8_t	CHDONE   			     : 1; 
	 __IO uint8_t	THERM_LIM       	 : 1; 
	 __IO uint8_t	VIN_ILIM		       : 1; 
	 __IO uint8_t	VIN_OK             : 1;  
	 __IO uint8_t	VIN_OV             : 1;
 } BITs;
} ADP5065_REG_CHARGERSTA1_T;
typedef enum {		//BATTERY_STATUS_E_T
	BATTERY_STATUS_MONITOR_OFF = 0x00,
	BATTERY_STATUS_NO_BATTERY = 0x01,
	BATTERY_STATUS_BAT_VSNS_LT_VTRK = 0x02,				//LT: lower than
	BATTERY_STATUS_BAT_VTRK_LT_VSNS_LT_VWEAK = 0x03,
	BATTERY_STATUS_BAT_SNS_BT_VWEAK = 0x04				//BT: bigger than
}BATTERY_STATUS_E_T;
typedef enum {
	THR_STATUS_OFF							= 0x00,
	THR_STATUS_BAT_COLD					= 0x01,
	THR_STATUS_BAT_COOL					= 0x02,
	THR_STATUS_BAT_WARM					= 0x03,
	THR_STATUS_BAT_HOT					= 0x04,
	THR_STATUS_RESERV_0x05			= 0x05,
	THR_STATUS_RESERV_0x06			= 0x06,
	THR_STATUS_BAT_OK						= 0x07
}THR_STATUS_T;


typedef union{		//ADP5065_REG_CHARGERSTA2_T
 __IO uint8_t  Val;
 struct{
	 BATTERY_STATUS_E_T	BATTERY_STATUS     : 3;
	 __IO uint8_t	Reserve  			     : 1; 
	 __IO uint8_t	IPK_STAT        	 : 1; 
	 THR_STATUS_T	THR_STATUS	       : 3;  
 } BITs;
}ADP5065_REG_CHARGERSTA2_T;
typedef union{		//ADP5065_REG_FAULTREG_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	TSD_140            : 1;
	 __IO uint8_t	TSDL_130  			   : 1; 
	 __IO uint8_t	IND_PEAK_INT       : 1; 
	 __IO uint8_t	BAT_SHR	           : 1;  
	 __IO uint8_t	Reserve  			     : 4; 
 } BITs;
} ADP5065_REG_FAULTREG_T;
typedef union{		//ADP5065_REG_BATSHORT_T
 __IO uint8_t  Val;
 struct{
	 __IO uint8_t	VBAT_SHR            : 3;
	 __IO uint8_t	Reserve  			      : 2; 
	 __IO uint8_t	TBAT_SHR            : 3;  
 } BITs;
} ADP5065_REG_BATSHORT_T;
typedef union{		//ADP5065_SFR_T		
	__IO uint8_t array[17];	//ARRAY
	struct{									//REG
	 ADP5065_REG_MANUINFO_T ManuInfo;
	 ADP5065_REG_SILICONVER_T SiliconVer;
	 ADP5065_REG_VINXSet_T VINxSet;
	 ADP5065_REG_TERMSET_T TermSet;
	 ADP5065_REG_CHARGECURR_T ChargeCur;
	 ADP5065_REG_VOLTTHR_T VoltThr;
	 ADP5065_REG_TIMERSET_T TimerSet;	
	 ADP5065_REG_FUNCSET1_T FuncSet1;
	 ADP5065_REG_FUNCSET2_T FuncSet2;
	 ADP5065_REG_INTENSET_T IntEnSet;
	 ADP5065_REG_INTACTSTA_T IntActSta;
	 ADP5065_REG_CHARGERSTA1_T ChargerSta1;
	 ADP5065_REG_CHARGERSTA2_T ChargerSta2;
	 ADP5065_REG_FAULTREG_T FaultReg;
	 union{		//NoDef_0x0E
		 __IO uint8_t  Reserve;
	 } NoDef_0x0E; 
	 union{		//NoDef_0x0F
		 __IO uint8_t  Reserve;
	 } NoDef_0x0F;
	 ADP5065_REG_BATSHORT_T BatShort;
	 union{		//NoDef_0x11
		 __IO uint8_t  Reserve;
	 } NoDef_0x11; 
	 union{		//NoDef_0x12
		 __IO uint8_t  Reserve;
	 } NoDef_0x12; 
	 union{		//NoDef_0x13
		 __IO uint8_t  Reserve;
	 } NoDef_0x13; 	 
 }reg; 
}ADP5065_SFR_T;		//FMT: Format, Array or Register

typedef union {
	__IO uint8_t array[6];	//ARRAY
	struct {
		uint8_t chno;
		ADP5065_REG_INTACTSTA_T IntActSta;
		ADP5065_REG_CHARGERSTA1_T ChargerSta1;
		ADP5065_REG_CHARGERSTA2_T ChargerSta2;
		ADP5065_REG_FAULTREG_T FaultReg;
		ADP5065_REG_BATSHORT_T BatShort;
	}reg;
}ADP5065_STATUS_T;

typedef struct{		//ADP5065

	const unsigned char id_writable[SIZE_ADP5065_WRITABLE_REG];
	const unsigned char id_readable[SIZE_ADP5065_READABLE_REG];
	unsigned char(*rd)(unsigned char regid);
	void(*wr)(unsigned char regid, unsigned char data);
} ADP5065_T;

extern ADP5065_T adp5065;
extern const ADP5065_SFR_T adp5065_default;
#endif /*ADP5065_H_*/

