
/*
*===========================================================
*        File Name: battery.h
*          Version: A1
*          Created: 2015-8-14
*         Revision: 00
*         Compiler: ARMCC.exe V5.03.0.76
*           Author: 
*          Company: Analog Devices Inc
*===========================================================
*/
#ifndef BATTERY_H_
#define BATTERY_H_

#include "inc\ADuCM360.h"
#include "inc\system_ADUCM360.h"
#include "i2c.h"
#include "adc.h"
#include "adp5065.h"                                                                                                                 

typedef enum {		//CHARGER_STATUS_E_T
	V_IN_TOO_HIGH = 0,
	V_IN_TOO_LOW = 1,
	V_IN_OK = 2,
	I_IN_LIMITED = 3,
	I_IN_OK = 4,
	DIE_TEMP_115 = 5,
	DIE_TEMP_130 = 6,
	DIE_TEMP_140 = 7,
	DIE_TEMP_OK = 8,                              
	BAT_ABSENT = 9,
	BAT_PRESENT = 10, 
	BAT_SHORT = 11,
	BAT_GOOD = 12,
	                   BAT_TEMP_COLD = 13,                                                
	BAT_TEMP_COOL = 14,  
	BAT_TEMP_WARM = 15,
	BAT_TEMP_HOT = 16,
	BAT_TEMP_OK = 17
} BAT_MONITOR_TEXT_INDEX_T;


typedef struct{		//BATTERY_DATA_T
	unsigned char f_upd; //f_upd = 1: data just updated and not be read into bat info buffer
	unsigned char f_upd_process;
	float vdis;
	float volt;
	float curr;
	float temp;
	float tempref;	
	float vdisrb;
	uint16_t raw_vdis;
	uint32_t raw_volt;
	uint32_t raw_curr;
                  
	uint32_t raw_temp;
	uint32_t raw_tempref;	
	uint32_t raw_vdisrb;

} BATTERY_T;








#endif /*BATTERY_H_*/
