
/*
*===========================================================
*        File Name: i2c.h
*          Version: A1
*          Created: 2015-8-14
*         Revision: 00
*         Compiler: ARMCC.exe V5.03.0.76
*           Author: 
*          Company: Analog Devices Inc
*===========================================================
*/
#ifndef I2C_H_
#define I2C_H_

#include "inc\ADuCM360.h"
#include "inc\system_ADUCM360.h"
#include "common\I2cLib.h"
#include "hardware.h"
#define I2CMSTA_ADDR 0x40003004
#define pI2CMSTA_REG ((I2CMSTA_T	*)I2CMSTA_ADDR)


typedef struct {
	union{					//REG
		unsigned short int Val;
		struct{				//BITs
			__IO uint16_t TXFSTA 		: 2;
			__IO uint16_t TXREQ  		: 1;
			__IO uint16_t RXREQ  		: 1;
			__IO uint16_t NACKADDR	: 1;
			__IO uint16_t BUSY  		: 1;
			__IO uint16_t NACKDATA 	: 1;
			__IO uint16_t TCOMP			: 1;
			__IO uint16_t RXOF			: 1;
			__IO uint16_t LINEBUSY	: 1;
			__IO uint16_t MSTOP			: 1;
			__IO uint16_t TXUR			: 1;
		}BITs;
	}REG;
} I2CMSTA_T;

typedef struct{
	I2CMSTA_T I2CMSTA;
	unsigned char wait_int;
	int (*init)(void);
	void (*x2id_wr)(unsigned short id1, unsigned short id2, unsigned short data);
	void (*x1id_wr)(unsigned short id, unsigned short data);
	unsigned char (*x2id_rd)(unsigned short id1, unsigned short id2);
	unsigned char (*x1id_rd)(unsigned short id);
	I2CMSTA_T (*mstatus)(void);
	unsigned char (*nackdata)(unsigned short id);
	unsigned char (*nackaddr)(unsigned short id);
	void(*Int_Handler)(void);
} I2C_T;

extern I2C_T i2c;


#endif /*I2C_H_*/

